//
//  ClientAPI.swift
//  TASQSample
//
//  Created by cheng on 2019/10/23.
//  Copyright © 2019 au.com.tasq. All rights reserved.
//

import Foundation
import UIKit
import Alamofire
import SwiftyJSON

class ClientAPI: UIViewController {
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
//        callCreateClientApi()
//
//        callEditClientApi()
//        
//        callDeleteClientApi()
//
//        callGetClientListApi()
        
//        callImportClientApi()
    }
    
    //Create
    func callCreateClientApi()
    {
        let client: Client = Client()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Job/CreateClient"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String:AnyObject]()
        var arrayData = [String:AnyObject]()

        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?

        var clientArrayData = [String:String]()
        clientArrayData["ClientID"] = (client.ClientID != nil) ? client.ClientID : ""
        clientArrayData["ClientName"] =  (client.ClientName != nil) ? client.ClientName : ""
        clientArrayData["JobContactTitle"] =   (client.JobContactTitle != nil) ? client.JobContactTitle : ""
        clientArrayData["JobContactFirstName"] =   (client.JobContactFirstName != nil) ? client.JobContactFirstName : ""
        clientArrayData["JobContactLastName"] =  (client.JobContactLastName != nil) ? client.JobContactLastName : ""
        clientArrayData["JobContactPhone"] =   (client.JobContactPhone != nil) ? client.JobContactPhone : ""
        clientArrayData["JobContactMobile"] =  (client.JobContactMobile != nil) ? client.JobContactMobile : ""
        clientArrayData["JobContactFax"] =  (client.JobContactFax != nil) ? client.JobContactFax : ""
        clientArrayData["JobContactEmail"] =  (client.JobContactEmail != nil) ? client.JobContactEmail : ""
        clientArrayData["IsSameAsJobContact"] =  "\(String(describing: client.IsSameAsJobContact))"
        clientArrayData["BillingContactTitle"] =  (client.BillingContactTitle != nil) ? client.BillingContactTitle : ""
        clientArrayData["BillingContactFirstName"] =  (client.BillingContactFirstName != nil) ? client.BillingContactFirstName : ""
        clientArrayData["BillingContactLastName"] =  (client.BillingContactLastName != nil) ? client.BillingContactLastName : ""
        clientArrayData["BillingContactMobile"] =  (client.BillingContactMobile != nil) ? client.BillingContactMobile : ""
        clientArrayData["BillingContactPhone"] =  (client.BillingContactMobile != nil) ? client.BillingContactPhone : ""
        clientArrayData["BillingContactFax"] =  (client.BillingContactFax != nil) ? client.BillingContactFax : ""
        clientArrayData["BillingContactEmail"] =  (client.BillingContactEmail != nil) ? client.BillingContactEmail : ""
        clientArrayData["Memos"] =  (client.Memos != nil) ? client.Memos : ""
        clientArrayData["JobAddress"] =  (client.JobAddress != nil) ? client.JobAddress : ""
        clientArrayData["JobAddressLine2"] =  (client.JobAddressLine2 != nil) ? client.JobAddressLine2 : ""
        clientArrayData["JobCity"] =  (client.JobCity != nil) ? client.JobCity : ""
        clientArrayData["JobState"] =  (client.JobState != nil) ? client.JobState : ""
        clientArrayData["JobPostalCode"] =  (client.JobPostalCode != nil) ? client.JobPostalCode : ""
        clientArrayData["JobCountry"] =  (client.JobCountry != nil) ? client.JobCountry : ""
        clientArrayData["IsSameAsJobAddress"] = "\(String(describing: client.IsSameAsJobAddress))"
        clientArrayData["BillingAddress"] =  (client.BillingAddress != nil) ? client.BillingAddress : ""
        clientArrayData["BillingAddressLine2"] =  (client.BillingAddressLine2 != nil) ? client.BillingAddressLine2 : ""
        clientArrayData["BillingCity"] =  (client.BillingCity != nil) ? client.BillingCity : ""
        clientArrayData["BillingState"] =  (client.BillingState != nil) ? client.BillingState : ""
        clientArrayData["BillingPostalCode"] =  (client.BillingPostalCode != nil) ? client.BillingPostalCode : ""
        clientArrayData["BillingCountry"] =  (client.BillingCountry != nil) ? client.BillingCountry: ""
        clientArrayData["ABN"] =  (client.ABN != nil) ? client.ABN : ""
        clientArrayData["DefaultSalesDiscount"] =  (client.DefaultSalesDiscount != nil) ? client.DefaultSalesDiscount : ""
        clientArrayData["BSBNumber"] =  (client.BSBNumber != nil) ? client.BSBNumber : ""
        clientArrayData["BankAccountNumber"] =  (client.BankAccountNumber != nil) ? client.BankAccountNumber : ""
        clientArrayData["BankAccountName"] =  (client.BankAccountName != nil) ? client.BankAccountName : ""
        clientArrayData["StatementText"] =  (client.StatementText != nil) ? client.StatementText : ""
        clientArrayData["PaymentMemos"] =  (client.PaymentMemos != nil) ? client.PaymentMemos : ""
        clientArrayData["DefaultSalesTaxCodeID"] =  (client.DefaultSalesTaxCodeID != nil) ? client.DefaultSalesTaxCodeID : ""
        clientArrayData["IsInactive"] = "false"
        clientArrayData["CreateDate"] =  (client.CreateDate != nil) ? client.CreateDate : ""
        clientArrayData["HasExportedToQ6"] = "false"
        // clientArrayData["NeedValidate"] = "false"
        parameters["Client"]  = clientArrayData as AnyObject
    
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    //Edit
    func callEditClientApi()
    {
        let client: Client = Client()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Job/EditClient"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String:AnyObject]()
        var arrayData = [String:AnyObject]()

        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?

        var clientArrayData = [String:String]()
        clientArrayData["ClientID"] = (client.ClientID != nil) ? client.ClientID : ""
        clientArrayData["ClientName"] =  (client.ClientName != nil) ? client.ClientName : ""
        clientArrayData["JobContactTitle"] =   (client.JobContactTitle != nil) ? client.JobContactTitle : ""
        clientArrayData["JobContactFirstName"] =   (client.JobContactFirstName != nil) ? client.JobContactFirstName : ""
        clientArrayData["JobContactLastName"] =  (client.JobContactLastName != nil) ? client.JobContactLastName : ""
        clientArrayData["JobContactPhone"] =   (client.JobContactPhone != nil) ? client.JobContactPhone : ""
        clientArrayData["JobContactMobile"] =  (client.JobContactMobile != nil) ? client.JobContactMobile : ""
        clientArrayData["JobContactFax"] =  (client.JobContactFax != nil) ? client.JobContactFax : ""
        clientArrayData["JobContactEmail"] =  (client.JobContactEmail != nil) ? client.JobContactEmail : ""
        clientArrayData["IsSameAsJobContact"] =  "\(String(describing: client.IsSameAsJobContact))"
        clientArrayData["BillingContactTitle"] =  (client.BillingContactTitle != nil) ? client.BillingContactTitle : ""
        clientArrayData["BillingContactFirstName"] =  (client.BillingContactFirstName != nil) ? client.BillingContactFirstName : ""
        clientArrayData["BillingContactLastName"] =  (client.BillingContactLastName != nil) ? client.BillingContactLastName : ""
        clientArrayData["BillingContactMobile"] =  (client.BillingContactMobile != nil) ? client.BillingContactMobile : ""
        clientArrayData["BillingContactPhone"] =  (client.BillingContactMobile != nil) ? client.BillingContactPhone : ""
        clientArrayData["BillingContactFax"] =  (client.BillingContactFax != nil) ? client.BillingContactFax : ""
        clientArrayData["BillingContactEmail"] =  (client.BillingContactEmail != nil) ? client.BillingContactEmail : ""
        clientArrayData["Memos"] =  (client.Memos != nil) ? client.Memos : ""
        clientArrayData["JobAddress"] =  (client.JobAddress != nil) ? client.JobAddress : ""
        clientArrayData["JobAddressLine2"] =  (client.JobAddressLine2 != nil) ? client.JobAddressLine2 : ""
        clientArrayData["JobCity"] =  (client.JobCity != nil) ? client.JobCity : ""
        clientArrayData["JobState"] =  (client.JobState != nil) ? client.JobState : ""
        clientArrayData["JobPostalCode"] =  (client.JobPostalCode != nil) ? client.JobPostalCode : ""
        clientArrayData["JobCountry"] =  (client.JobCountry != nil) ? client.JobCountry : ""
        clientArrayData["IsSameAsJobAddress"] = "\(String(describing: client.IsSameAsJobAddress))"
        clientArrayData["BillingAddress"] =  (client.BillingAddress != nil) ? client.BillingAddress : ""
        clientArrayData["BillingAddressLine2"] =  (client.BillingAddressLine2 != nil) ? client.BillingAddressLine2 : ""
        clientArrayData["BillingCity"] =  (client.BillingCity != nil) ? client.BillingCity : ""
        clientArrayData["BillingState"] =  (client.BillingState != nil) ? client.BillingState : ""
        clientArrayData["BillingPostalCode"] =  (client.BillingPostalCode != nil) ? client.BillingPostalCode : ""
        clientArrayData["BillingCountry"] =  (client.BillingCountry != nil) ? client.BillingCountry: ""
        clientArrayData["ABN"] =  (client.ABN != nil) ? client.ABN : ""
        clientArrayData["DefaultSalesDiscount"] =  (client.DefaultSalesDiscount != nil) ? client.DefaultSalesDiscount : ""
        clientArrayData["BSBNumber"] =  (client.BSBNumber != nil) ? client.BSBNumber : ""
        clientArrayData["BankAccountNumber"] =  (client.BankAccountNumber != nil) ? client.BankAccountNumber : ""
        clientArrayData["BankAccountName"] =  (client.BankAccountName != nil) ? client.BankAccountName : ""
        clientArrayData["StatementText"] =  (client.StatementText != nil) ? client.StatementText : ""
        clientArrayData["PaymentMemos"] =  (client.PaymentMemos != nil) ? client.PaymentMemos : ""
        clientArrayData["DefaultSalesTaxCodeID"] =  (client.DefaultSalesTaxCodeID != nil) ? client.DefaultSalesTaxCodeID : ""
        clientArrayData["IsInactive"] = "false"
        clientArrayData["CreateDate"] =  (client.CreateDate != nil) ? client.CreateDate : ""
        clientArrayData["HasExportedToQ6"] = "false"
        // clientArrayData["NeedValidate"] = "false"
        parameters["Client"]  = clientArrayData as AnyObject
    
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    //delete
    func callDeleteClientApi()
    {
        let client: Client = Client()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Job/DeleteClient"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String: AnyObject]()
        var arrayData = [String: AnyObject]()
        
        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?
        parameters["ID"] = client.ClientID as AnyObject
//        parameters["SendFromUserID"] = "false"
//        parameters["NeedValidate"] = "false"
        
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    func callGetClientListApi()
    {
        let loginDetail: LoginDetail = LoginDetail()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl
        var arrayData = [String: AnyObject]()
        
        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        let jasonLoginDeail = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: arrayData as [String : AnyObject])
        
        let attachedURL: String = "&IsLoadInactive=true"
        
        let EncodeAttachedURL = (jasonLoginDeail + attachedURL).addingPercentEncoding(withAllowedCharacters: .urlHostAllowed )! as String
        
        let url : String = UrlString + "Item/GetClientList?Jsonlogin="  + EncodeAttachedURL
    
        let replacedUrlString = url.replacingOccurrences(of: "\\", with:"" )
        
        let request = NSMutableURLRequest(url: NSURL(string: replacedUrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        request.httpMethod = "GET"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    //Import
    func callImportClientApi()
    {
        let client: Client = Client()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Job/ImportClient"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String:AnyObject]()
        var arrayData = [String:AnyObject]()

        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?

        var clientArrayData = [String:String]()
        clientArrayData["ClientID"] = (client.ClientID != nil) ? client.ClientID : ""
        clientArrayData["ClientName"] =  (client.ClientName != nil) ? client.ClientName : ""
        clientArrayData["JobContactTitle"] =   (client.JobContactTitle != nil) ? client.JobContactTitle : ""
        clientArrayData["JobContactFirstName"] =   (client.JobContactFirstName != nil) ? client.JobContactFirstName : ""
        clientArrayData["JobContactLastName"] =  (client.JobContactLastName != nil) ? client.JobContactLastName : ""
        clientArrayData["JobContactPhone"] =   (client.JobContactPhone != nil) ? client.JobContactPhone : ""
        clientArrayData["JobContactMobile"] =  (client.JobContactMobile != nil) ? client.JobContactMobile : ""
        clientArrayData["JobContactFax"] =  (client.JobContactFax != nil) ? client.JobContactFax : ""
        clientArrayData["JobContactEmail"] =  (client.JobContactEmail != nil) ? client.JobContactEmail : ""
        clientArrayData["IsSameAsJobContact"] =  "\(String(describing: client.IsSameAsJobContact))"
        clientArrayData["BillingContactTitle"] =  (client.BillingContactTitle != nil) ? client.BillingContactTitle : ""
        clientArrayData["BillingContactFirstName"] =  (client.BillingContactFirstName != nil) ? client.BillingContactFirstName : ""
        clientArrayData["BillingContactLastName"] =  (client.BillingContactLastName != nil) ? client.BillingContactLastName : ""
        clientArrayData["BillingContactMobile"] =  (client.BillingContactMobile != nil) ? client.BillingContactMobile : ""
        clientArrayData["BillingContactPhone"] =  (client.BillingContactMobile != nil) ? client.BillingContactPhone : ""
        clientArrayData["BillingContactFax"] =  (client.BillingContactFax != nil) ? client.BillingContactFax : ""
        clientArrayData["BillingContactEmail"] =  (client.BillingContactEmail != nil) ? client.BillingContactEmail : ""
        clientArrayData["Memos"] =  (client.Memos != nil) ? client.Memos : ""
        clientArrayData["JobAddress"] =  (client.JobAddress != nil) ? client.JobAddress : ""
        clientArrayData["JobAddressLine2"] =  (client.JobAddressLine2 != nil) ? client.JobAddressLine2 : ""
        clientArrayData["JobCity"] =  (client.JobCity != nil) ? client.JobCity : ""
        clientArrayData["JobState"] =  (client.JobState != nil) ? client.JobState : ""
        clientArrayData["JobPostalCode"] =  (client.JobPostalCode != nil) ? client.JobPostalCode : ""
        clientArrayData["JobCountry"] =  (client.JobCountry != nil) ? client.JobCountry : ""
        clientArrayData["IsSameAsJobAddress"] = "\(String(describing: client.IsSameAsJobAddress))"
        clientArrayData["BillingAddress"] =  (client.BillingAddress != nil) ? client.BillingAddress : ""
        clientArrayData["BillingAddressLine2"] =  (client.BillingAddressLine2 != nil) ? client.BillingAddressLine2 : ""
        clientArrayData["BillingCity"] =  (client.BillingCity != nil) ? client.BillingCity : ""
        clientArrayData["BillingState"] =  (client.BillingState != nil) ? client.BillingState : ""
        clientArrayData["BillingPostalCode"] =  (client.BillingPostalCode != nil) ? client.BillingPostalCode : ""
        clientArrayData["BillingCountry"] =  (client.BillingCountry != nil) ? client.BillingCountry: ""
        clientArrayData["ABN"] =  (client.ABN != nil) ? client.ABN : ""
        clientArrayData["DefaultSalesDiscount"] =  (client.DefaultSalesDiscount != nil) ? client.DefaultSalesDiscount : ""
        clientArrayData["BSBNumber"] =  (client.BSBNumber != nil) ? client.BSBNumber : ""
        clientArrayData["BankAccountNumber"] =  (client.BankAccountNumber != nil) ? client.BankAccountNumber : ""
        clientArrayData["BankAccountName"] =  (client.BankAccountName != nil) ? client.BankAccountName : ""
        clientArrayData["StatementText"] =  (client.StatementText != nil) ? client.StatementText : ""
        clientArrayData["PaymentMemos"] =  (client.PaymentMemos != nil) ? client.PaymentMemos : ""
        clientArrayData["DefaultSalesTaxCodeID"] =  (client.DefaultSalesTaxCodeID != nil) ? client.DefaultSalesTaxCodeID : ""
        clientArrayData["IsInactive"] = "false"
        clientArrayData["CreateDate"] =  (client.CreateDate != nil) ? client.CreateDate : ""
        clientArrayData["HasExportedToQ6"] = "false"
        // clientArrayData["NeedValidate"] = "false"
        parameters["ImportClientViewList"]  = [clientArrayData as AnyObject] as AnyObject
    
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    //request Post
    func callTASQPostAPIClient(APIURL: String, parameters: Parameters)
    {
        Alamofire.request(APIURL,method: .post,parameters: parameters).validate().responseJSON { response in
            switch response.result {
                case .success(let value):
                    let swiftyJsonVar = JSON(value)
                    print(swiftyJsonVar)
                    let isSuccessed = swiftyJsonVar["IsSuccessed"].stringValue
                    
                    if isSuccessed == "YES" {

                    }else {
                        
                    }
                case .failure(let error):
                    print(error)
            }
        }
    }
    
    //request Get
    func callTASQGetAPIClient(APIURL: String)
    {
        Alamofire.request(APIURL).validate().responseJSON { response in
            switch response.result {
                case .success(let value):
                    let swiftyJsonVar = JSON(value)
                    print(swiftyJsonVar)
                    let isSuccessed = swiftyJsonVar["IsSuccessed"].stringValue
                    
                    if isSuccessed == "YES" {

                    }else {
                        
                    }
                case .failure(let error):
                    print(error)
            }
        }
    }
}
