//
//  InventoryAPI.swift
//  TASQSample
//
//  Created by cheng on 2019/10/22.
//  Copyright © 2019 au.com.tasq. All rights reserved.
//

import Foundation
import UIKit
import Alamofire
import SwiftyJSON

class InventoryAPI: UIViewController {
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
//        callCreateInventoryApi()
//
//        callEditInventoryApi()
//
//        callDeleteInventoryApi()
//
//        callGetInventoryListApi()
//
//        callImportInventoryApi()
    }
    
    //Create
    func callCreateInventoryApi()
    {
        let inventory: Inventory = Inventory()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Item/CreateInventory"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String : AnyObject]()
        var arrayData = [String : AnyObject]()
        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?

        var inventoryData = [String : AnyObject]()
        inventoryData["InventoryID"] = inventory.InventoryID as AnyObject
        inventoryData["InventoryName"] =  inventory.InventoryName as AnyObject
        inventoryData["InventoryType"] =   inventory.InventoryType as AnyObject
        inventoryData["SupplierPartNumber"] =   inventory.SupplierPartNumber as AnyObject
        inventoryData["CategoryID"] =  inventory.CategoryID as AnyObject
        inventoryData["PurchasePrice"] =   inventory.PurchasePrice as AnyObject
        inventoryData["IsPurchasePriceTaxInclusive"] =  inventory.IsPurchasePriceTaxInclusive as AnyObject
        inventoryData["PurchaseTaxCodeID"] =  inventory.PurchaseTaxCodeID as AnyObject
        inventoryData["SellingPrice"] =  inventory.SellingPrice as AnyObject
        inventoryData["IsSalePriceTaxInclusive"] = inventory.IsSalePriceTaxInclusive as AnyObject
        inventoryData["SaleDescription"] =  inventory.SaleDescription as AnyObject
        inventoryData["SaleTaxCodeID"] =  inventory.SaleTaxCodeID as AnyObject
        inventoryData["IsInventory"] =  inventory.IsInventory as AnyObject
        inventoryData["IsInactive"] =  inventory.IsInactive as AnyObject
        inventoryData["IsRecordTimeTracking"] =  inventory.IsRecordingTimeTracking as AnyObject
        inventoryData["IsDefaultRecordTimeTracking"] =   inventory.IsDefaultRecordTimeTracking as AnyObject
        
        parameters["Inventory"]  = inventoryData as AnyObject
        
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    //Edit
    func callEditInventoryApi()
    {
        let inventory: Inventory = Inventory()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Item/EditInventory"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String : AnyObject]()
        var arrayData = [String : AnyObject]()
        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?

        var inventoryData = [String : AnyObject]()
        inventoryData["InventoryID"] = inventory.InventoryID as AnyObject
        inventoryData["InventoryName"] =  inventory.InventoryName as AnyObject
        inventoryData["InventoryType"] =   inventory.InventoryType as AnyObject
        inventoryData["SupplierPartNumber"] =   inventory.SupplierPartNumber as AnyObject
        inventoryData["CategoryID"] =  inventory.CategoryID as AnyObject
        inventoryData["PurchasePrice"] =   inventory.PurchasePrice as AnyObject
        inventoryData["IsPurchasePriceTaxInclusive"] =  inventory.IsPurchasePriceTaxInclusive as AnyObject
        inventoryData["PurchaseTaxCodeID"] =  inventory.PurchaseTaxCodeID as AnyObject
        inventoryData["SellingPrice"] =  inventory.SellingPrice as AnyObject
        inventoryData["IsSalePriceTaxInclusive"] = inventory.IsSalePriceTaxInclusive as AnyObject
        inventoryData["SaleDescription"] =  inventory.SaleDescription as AnyObject
        inventoryData["SaleTaxCodeID"] =  inventory.SaleTaxCodeID as AnyObject
        inventoryData["IsInventory"] =  inventory.IsInventory as AnyObject
        inventoryData["IsInactive"] =  inventory.IsInactive as AnyObject
        inventoryData["IsRecordTimeTracking"] =  inventory.IsRecordingTimeTracking as AnyObject
        inventoryData["IsDefaultRecordTimeTracking"] =   inventory.IsDefaultRecordTimeTracking as AnyObject
        
        parameters["Inventory"]  = inventoryData as AnyObject
        
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    //delete
    func callDeleteInventoryApi()
    {
        let inventory: Inventory = Inventory()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Item/DeleteInventory"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String : AnyObject]()
        var arrayData = [String : AnyObject]()
        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?

        var inventoryData = [String : AnyObject]()
        inventoryData["ID"] = inventory.InventoryID! as AnyObject
        inventoryData["NeedValidate"] = "NO" as AnyObject
        
        parameters["Inventory"]  = inventoryData as AnyObject
        
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    func callGetInventoryListApi()
    {
        let loginDetail: LoginDetail = LoginDetail()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl
        let byEmail = loginDetail.LoginEmail
        let property: String = "all"
        let searchText: String = ""
        var arrayData = [String : AnyObject]()
        let pageSize = 10000
        
        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        let jasonLoginDeail = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: arrayData as [String : AnyObject])
        
        let attachedURL: String = "&byEmail=" + byEmail + "&Property=" + property + "&SearchText=" + searchText  + "&IsLoadInactive=" + "NO" +  "&PageSize=" + String(pageSize) + "&PageIndex=1"
        
        let EncodeAttachedURL = (jasonLoginDeail + attachedURL).addingPercentEncoding(withAllowedCharacters: .urlHostAllowed )! as String
        
        let url : String = UrlString + "Item/GetInventoryList?Jsonlogin="  + EncodeAttachedURL

        let replacedUrlString = url.replacingOccurrences(of: "\\", with:"" )
        
        let request = NSMutableURLRequest(url: NSURL(string: replacedUrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        request.httpMethod = "GET"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    //import
    func callImportInventoryApi()
    {
        let inventory: Inventory = Inventory()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Item/ImportInventory"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String : AnyObject]()
        var arrayData = [String : AnyObject]()
        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?
        
        parameters["columnList"] = ["*InventoryName", "*InventoryType", "IsInventoried", "SupplierPartNumber", "CategoryName", "BuyingPrice", "IsPurchasePriceTaxInclusive", "PurchaseTaxCodeName", "SellingPrice", "IsSalePriceTaxInclusive", "SaleDescription", "IsRecordTimeTracking", "IsDefaultRecordTimeTracking"] as AnyObject
        
        var inventoryData = [String : AnyObject]()
        inventoryData["InventoryID"] = inventory.InventoryID as AnyObject
        inventoryData["InventoryName"] =  inventory.InventoryName as AnyObject
        inventoryData["InventoryType"] =   inventory.InventoryType as AnyObject
        inventoryData["SupplierPartNumber"] =   inventory.SupplierPartNumber as AnyObject
        inventoryData["CategoryID"] =  inventory.CategoryID as AnyObject
        inventoryData["PurchasePrice"] =   inventory.PurchasePrice as AnyObject
        inventoryData["IsPurchasePriceTaxInclusive"] =  inventory.IsPurchasePriceTaxInclusive as AnyObject
        inventoryData["PurchaseTaxCodeID"] =  inventory.PurchaseTaxCodeID as AnyObject
        inventoryData["SellingPrice"] =  inventory.SellingPrice as AnyObject
        inventoryData["IsSalePriceTaxInclusive"] = inventory.IsSalePriceTaxInclusive as AnyObject
        inventoryData["SaleDescription"] =  inventory.SaleDescription as AnyObject
        inventoryData["SaleTaxCodeID"] =  inventory.SaleTaxCodeID as AnyObject
        inventoryData["IsInventory"] =  inventory.IsInventory as AnyObject
        inventoryData["IsInactive"] =  inventory.IsInactive as AnyObject
        inventoryData["IsRecordTimeTracking"] =  inventory.IsRecordingTimeTracking as AnyObject
        inventoryData["IsDefaultRecordTimeTracking"] =   inventory.IsDefaultRecordTimeTracking as AnyObject
        
        parameters["Inventory"]  = [inventoryData as AnyObject] as AnyObject
        
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    //request Post
    func callTASQPostAPIClient(APIURL: String, parameters: Parameters)
    {
        Alamofire.request(APIURL,method: .post,parameters: parameters).validate().responseJSON { response in
            switch response.result {
                case .success(let value):
                    let swiftyJsonVar = JSON(value)
                    print(swiftyJsonVar)
                    let isSuccessed = swiftyJsonVar["IsSuccessed"].stringValue
                    
                    if isSuccessed == "YES" {

                    }else {
                        
                    }
                case .failure(let error):
                    print(error)
            }
        }
    }
    
    //request Get
    func callTASQGetAPIClient(APIURL: String)
    {
        Alamofire.request(APIURL).validate().responseJSON { response in
            switch response.result {
                case .success(let value):
                    let swiftyJsonVar = JSON(value)
                    print(swiftyJsonVar)
                    let isSuccessed = swiftyJsonVar["IsSuccessed"].stringValue
                    
                    if isSuccessed == "YES" {

                    }else {
                        
                    }
                case .failure(let error):
                    print(error)
            }
        }
    }
    
    func getAllPropertys()->[String]
    {
        var result = [String]()
        let count = UnsafeMutablePointer<UInt32>.allocate(capacity: 0)
        let buff = class_copyPropertyList(object_getClass(self), count)
        let countInt = Int(count[0])
        for i in 0...countInt{
            let temp = buff![i]
            let tempPro = property_getName(temp)
            let proper = String(validatingUTF8: tempPro)
            result.append(proper!)
        }
        return result
    }
}

