//
//  JobAPI.swift
//  TASQSample
//
//  Created by cheng on 2019/10/23.
//  Copyright © 2019 au.com.tasq. All rights reserved.
//

import Foundation
import UIKit
import Alamofire
import SwiftyJSON

class JobAPI: UIViewController {
    
    let job: Job = Job()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any ladditional setup after loading the view.
//        callCreateJobApi()
//
//        callEditJobApi()
//        
//        callDeleteJobApi()
//
//        callGetJobListApi()
    }
    
    //Create
    func callCreateJobApi()
    {
        let jobJSONData: JobJSONData = JobJSONData()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Job/CreateJob"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String:AnyObject]()
        var arrayData = [String:AnyObject]()

        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?

        jobJSONData.JobTransactionHeaderJSONData = getJobTransactionHeaderJsonData()
        
        parameters["JobTransactionHeader"] = jobJSONData.JobTransactionHeaderJSONData as AnyObject
        parameters["JobTransactionDetail"] =  jobJSONData.JobTransactionDetailJSONData as AnyObject
        parameters["JobScheduleDateTime"] =  jobJSONData.JobScheduleDateTimeJSONData as AnyObject
        parameters["JobTasks"] =  jobJSONData.JobTasksJSONData as AnyObject
        parameters["JobRecordTime"] =   jobJSONData.JobRecordTimeJSONData as AnyObject
        parameters["Note"] =  jobJSONData.NoteJSONData as AnyObject
        parameters["Photo"] =  jobJSONData.PhotoJSONData as AnyObject
        parameters["ClientSignOff"] =  jobJSONData.ClientSignOff as AnyObject
        parameters["SendFromUserID"] =  "" as AnyObject
    
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    //Edit
    func callEditJobApi()
    {
        let jobJSONData: JobJSONData = JobJSONData()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Job/EditJob"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String:AnyObject]()
        var arrayData = [String:AnyObject]()

        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?

        jobJSONData.JobTransactionHeaderJSONData = getJobTransactionHeaderJsonData()
        jobJSONData.ClientSignOff = getClientSignOff()
        //As shown above
        jobJSONData.JobTransactionDetailJSONData = getJobTransactionDetailJSONData()
        jobJSONData.JobScheduleDateTimeJSONData = getJobScheduleDateTimeJSONData()
        jobJSONData.JobTasksJSONData = getJobTasksJSONData()
        jobJSONData.JobRecordTimeJSONData = getJobRecordTimeJSONData()
        jobJSONData.NoteJSONData = getNoteJSONData()
        jobJSONData.PhotoJSONData = getPhotoJSONData()
        
        parameters["JobTransactionHeader"] = jobJSONData.JobTransactionHeaderJSONData as AnyObject
        parameters["JobTransactionDetail"] =  jobJSONData.JobTransactionDetailJSONData as AnyObject
        parameters["JobScheduleDateTime"] =  jobJSONData.JobScheduleDateTimeJSONData as AnyObject
        parameters["JobTasks"] =  jobJSONData.JobTasksJSONData as AnyObject
        parameters["JobRecordTime"] =   jobJSONData.JobRecordTimeJSONData as AnyObject
        parameters["Note"] =  jobJSONData.NoteJSONData as AnyObject
        parameters["Photo"] =  jobJSONData.PhotoJSONData as AnyObject
        parameters["ClientSignOff"] =  jobJSONData.ClientSignOff as AnyObject
        parameters["SendFromUserID"] =  "" as AnyObject
    
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    //delete
    func callDeleteJobApi()
    {
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Job/DeleteJob"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String:AnyObject]()
        var arrayData = [String:AnyObject]()

        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?
        parameters["ID"]  = "" as AnyObject?
        parameters["NeedValidate"]  = "NO" as AnyObject?
        parameters["SendFromUserID"]  = "" as AnyObject?
    
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    func callGetJobListApi()
    {
        let loginDetail: LoginDetail = LoginDetail()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl
        var arrayData = [String:AnyObject]()
        
        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        let jasonLoginDeail = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: arrayData as [String : AnyObject])
        
        let attachedURL: String = ""
        
        let EncodeAttachedURL = (jasonLoginDeail + attachedURL).addingPercentEncoding(withAllowedCharacters: .urlHostAllowed )! as String
        
        let url : String = UrlString + "Job/GetJobList?Jsonlogin="  + EncodeAttachedURL
    
        let replacedUrlString = url.replacingOccurrences(of: "\\", with:"" )

        let request = NSMutableURLRequest(url: NSURL(string: replacedUrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        request.httpMethod = "GET"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    func getJobTransactionHeaderJsonData() -> [String:AnyObject]
    {
        var jobTransactionJsonData = [String:AnyObject]()
        
        let emptyStr = "" as AnyObject

        jobTransactionJsonData["JobTransactionHeaderID"] = (job.jobTransactionHeader.JobTransactionHeaderID != nil) ? job.jobTransactionHeader.JobTransactionHeaderID as AnyObject : emptyStr

        jobTransactionJsonData["ReferenceNo"] = (job.jobTransactionHeader.ReferenceNo != nil) ? job.jobTransactionHeader.ReferenceNo as AnyObject : emptyStr

        jobTransactionJsonData["JobType"] = (job.jobTransactionHeader.JobType != nil) ? job.jobTransactionHeader.JobType as AnyObject : emptyStr

        jobTransactionJsonData["JobStatus"] = (job.jobTransactionHeader.JobStatus != nil) ? job.jobTransactionHeader.JobStatus as AnyObject : emptyStr

        jobTransactionJsonData["TransactionDate"] = (job.jobTransactionHeader.TransactionDate != nil) ? job.jobTransactionHeader.TransactionDate as AnyObject : emptyStr

        jobTransactionJsonData["ClientID"] = (job.jobTransactionHeader.ClientID != nil) ? job.jobTransactionHeader.ClientID as AnyObject : emptyStr
        
        jobTransactionJsonData["ClientPurchaseNo"] = (job.jobTransactionHeader.ClientPurchaseNo != nil) ? job.jobTransactionHeader.ClientPurchaseNo as AnyObject : emptyStr
        
        jobTransactionJsonData["JobCategoryID"] = (job.jobTransactionHeader.JobCategoryID != nil) ? job.jobTransactionHeader.JobCategoryID as AnyObject : emptyStr
        

        jobTransactionJsonData["HasApproval"] = (job.jobTransactionHeader.HasApproval != nil) ? job.jobTransactionHeader.HasApproval as AnyObject : emptyStr
        
        jobTransactionJsonData["DueDate"] = (job.jobTransactionHeader.DueDate != nil) ? job.jobTransactionHeader.DueDate as AnyObject : emptyStr
        
        jobTransactionJsonData["SubTotal"] = (job.jobTransactionHeader.SubTotal != nil) ? job.jobTransactionHeader.SubTotal as AnyObject : emptyStr

        jobTransactionJsonData["TaxTotal"] = (job.jobTransactionHeader.TaxTotal != nil) ? job.jobTransactionHeader.TaxTotal as AnyObject : emptyStr

        jobTransactionJsonData["TotalAmount"] = (job.jobTransactionHeader.TotalAmount != nil) ? job.jobTransactionHeader.TotalAmount as AnyObject : emptyStr
        
        jobTransactionJsonData["Memo"] = (job.jobTransactionHeader.Memo != nil) ? job.jobTransactionHeader.Memo as AnyObject : emptyStr

        jobTransactionJsonData["JobAddress"] = (job.jobTransactionHeader.JobAddress != nil) ? job.jobTransactionHeader.JobAddress as AnyObject : emptyStr

        jobTransactionJsonData["JobAddressLine2"] = (job.jobTransactionHeader.JobAddressLine2 != nil) ? job.jobTransactionHeader.JobAddressLine2 as AnyObject : emptyStr
        
        jobTransactionJsonData["JobCity"] = (job.jobTransactionHeader.JobCity != nil) ? job.jobTransactionHeader.JobCity as AnyObject : emptyStr

        jobTransactionJsonData["JobState"] = (job.jobTransactionHeader.JobState != nil) ? job.jobTransactionHeader.JobState as AnyObject : emptyStr

        jobTransactionJsonData["JobPostalCode"] = (job.jobTransactionHeader.JobPostalCode != nil) ? job.jobTransactionHeader.JobPostalCode as AnyObject : emptyStr

        jobTransactionJsonData["JobCountry"] = (job.jobTransactionHeader.JobCountry != nil) ? job.jobTransactionHeader.JobCountry as AnyObject : emptyStr

        jobTransactionJsonData["JobContactTitle"] = (job.jobTransactionHeader.JobContactTitle != nil) ? job.jobTransactionHeader.JobContactTitle as AnyObject : emptyStr

        jobTransactionJsonData["JobContactFirstName"] = (job.jobTransactionHeader.JobContactFirstName != nil) ? job.jobTransactionHeader.JobContactFirstName as AnyObject : emptyStr
        
        jobTransactionJsonData["JobContactLastName"] = (job.jobTransactionHeader.JobContactLastName != nil) ? job.jobTransactionHeader.JobContactLastName as AnyObject : emptyStr

        jobTransactionJsonData["JobContactPhone"] = (job.jobTransactionHeader.JobContactPhone != nil) ? job.jobTransactionHeader.JobContactPhone as AnyObject : emptyStr

        jobTransactionJsonData["JobContactFax"] = (job.jobTransactionHeader.JobContactFax != nil) ? job.jobTransactionHeader.JobContactFax as AnyObject : emptyStr

        jobTransactionJsonData["JobContactMobile"] = (job.jobTransactionHeader.JobContactMobile != nil) ? job.jobTransactionHeader.JobContactMobile as AnyObject : emptyStr

        jobTransactionJsonData["JobContactEmail"] = (job.jobTransactionHeader.JobContactEmail != nil) ? job.jobTransactionHeader.JobContactEmail as AnyObject : emptyStr
        
        jobTransactionJsonData["JobDescription"] = (job.jobTransactionHeader.JobDescription != nil) ? job.jobTransactionHeader.JobDescription as AnyObject : emptyStr

        jobTransactionJsonData["IsSameAsJobAddress"] = "true" as AnyObject

        jobTransactionJsonData["BillingAddress"] = (job.jobTransactionHeader.BillingAddress != nil) ? job.jobTransactionHeader.BillingAddress as AnyObject : emptyStr
 
        jobTransactionJsonData["BillingAddressLine2"] = (job.jobTransactionHeader.BillingAddressLine2 != nil) ? job.jobTransactionHeader.BillingAddressLine2 as AnyObject : emptyStr
        
        jobTransactionJsonData["BillingCity"] = (job.jobTransactionHeader.BillingCity != nil) ? job.jobTransactionHeader.BillingCity as AnyObject : emptyStr

        jobTransactionJsonData["BillingState"] = (job.jobTransactionHeader.BillingState != nil) ? job.jobTransactionHeader.BillingState as AnyObject : emptyStr

        jobTransactionJsonData["BillingPostalCode"] = (job.jobTransactionHeader.BillingPostalCode != nil) ? job.jobTransactionHeader.BillingPostalCode as AnyObject : emptyStr

        jobTransactionJsonData["BillingCountry"] = (job.jobTransactionHeader.BillingCountry != nil) ? job.jobTransactionHeader.BillingCountry as AnyObject : emptyStr

             jobTransactionJsonData["IsSameAsJobContact"] = "false" as AnyObject

        jobTransactionJsonData["BillingContactTitle"] = (job.jobTransactionHeader.BillingContactTitle != nil) ? job.jobTransactionHeader.BillingContactTitle as AnyObject : emptyStr

        jobTransactionJsonData["BillingContactFirstName"] = (job.jobTransactionHeader.BillingContactFirstName != nil) ? job.jobTransactionHeader.BillingContactFirstName as AnyObject : emptyStr

        jobTransactionJsonData["BillingContactLastName"] = (job.jobTransactionHeader.BillingContactLastName != nil) ? job.jobTransactionHeader.BillingContactLastName as AnyObject : emptyStr

        jobTransactionJsonData["BillingContactPhone"] = (job.jobTransactionHeader.BillingContactPhone != nil) ? job.jobTransactionHeader.BillingContactPhone as AnyObject : emptyStr
        
        jobTransactionJsonData["BillingContactFax"] = (job.jobTransactionHeader.BillingContactFax != nil) ? job.jobTransactionHeader.BillingContactFax as AnyObject : emptyStr
        
        jobTransactionJsonData["BillingContactMobile"] = (job.jobTransactionHeader.BillingContactMobile != nil) ? job.jobTransactionHeader.BillingContactMobile as AnyObject : emptyStr

        jobTransactionJsonData["BillingContactEmail"] = (job.jobTransactionHeader.BillingContactEmail != nil) ? job.jobTransactionHeader.BillingContactEmail as AnyObject : emptyStr

        jobTransactionJsonData["BillingMemo"] = (job.jobTransactionHeader.BillingMemo != nil) ? job.jobTransactionHeader.BillingMemo as AnyObject : emptyStr
        
        jobTransactionJsonData["IsCreatedByRecurring"] = (job.jobTransactionHeader.IsCreatedByRecurring != nil) ? job.jobTransactionHeader.IsCreatedByRecurring as AnyObject : emptyStr
        
        jobTransactionJsonData["RecurringTemplateID"] = (job.jobTransactionHeader.RecurringTemplateID != nil) ? job.jobTransactionHeader.RecurringTemplateID as AnyObject : emptyStr
        
        jobTransactionJsonData["HasLinkedDoc"] = (job.jobTransactionHeader.HasLinkedDoc != nil) ? job.jobTransactionHeader.HasLinkedDoc as AnyObject : emptyStr
        
        jobTransactionJsonData["IsShowOnPDF"] = (job.jobTransactionHeader.IsShowOnPDF != nil) ? job.jobTransactionHeader.IsShowOnPDF as AnyObject : emptyStr
        
        jobTransactionJsonData["TaxInclusive"] = (job.jobTransactionHeader.TaxInclusive != nil) ? job.jobTransactionHeader.TaxInclusive as AnyObject : emptyStr
        
        jobTransactionJsonData["IsDeleted"] = (job.jobTransactionHeader.IsDeleted != nil) ? job.jobTransactionHeader.IsDeleted as AnyObject : emptyStr
        
        jobTransactionJsonData["IsJobCompleted"] = (job.jobTransactionHeader.IsJobCompleted != nil) ? job.jobTransactionHeader.IsJobCompleted as AnyObject : emptyStr
        
        jobTransactionJsonData["HasViewed"] = (job.jobTransactionHeader.HasViewed != nil) ? job.jobTransactionHeader.HasViewed as AnyObject : emptyStr
        
        jobTransactionJsonData["ClientName"] = (job.jobTransactionHeader.ClientName != nil) ? job.jobTransactionHeader.ClientName as AnyObject : emptyStr

        jobTransactionJsonData["CreateTime"] = (job.jobTransactionHeader.CreateTime != nil) ? job.jobTransactionHeader.CreateTime as AnyObject : emptyStr

        jobTransactionJsonData["ClosedDate"] = (job.jobTransactionHeader.ClosedDate != nil) ? job.jobTransactionHeader.ClosedDate as AnyObject : emptyStr
        jobTransactionJsonData["LastModifiedTime"] = (job.jobTransactionHeader.LastModifiedTime != nil) ? job.jobTransactionHeader.LastModifiedTime as AnyObject : emptyStr
        
        let isAuthorisedJob = job.jobTransactionHeader.IsAuthorisedJob
        if isAuthorisedJob == true
        {
            jobTransactionJsonData["IsAuthorisedJob"] = "true" as AnyObject
        }
        else{
            jobTransactionJsonData["IsAuthorisedJob"] = "false" as AnyObject
        }
        return jobTransactionJsonData
    }
    
    func getClientSignOff() -> [[String: AnyObject]] {
        var clientSignOff = [[String: AnyObject]]()
        let clientSignOffList = [ClientSignOff]()
        for i in 0..<clientSignOffList.count
        {
            var tempClientSignOff = [String:AnyObject]()
            tempClientSignOff["ClientSignOffID"] =  clientSignOffList[i].ClientSignOffID as AnyObject
            tempClientSignOff["ClientSignOffDateTimeUTC"] = clientSignOffList[i].ClientSignOffDateTimeUTC?.description as AnyObject
            tempClientSignOff["IsDeleted"] =  clientSignOffList[i].IsDeleted as AnyObject
            tempClientSignOff["ClientSignOffImage"] =  clientSignOffList[i].ClientSignOffImage as AnyObject
            tempClientSignOff["JobID"] =  clientSignOffList[i].JobID as AnyObject
            tempClientSignOff["UserID"] =  clientSignOffList[i].UserID as AnyObject
            clientSignOff.append(tempClientSignOff)
        }
        return clientSignOff
    }
    //As shown above
    func getJobTransactionDetailJSONData() -> [[String: AnyObject]] {
        let jobTransactionDetailJSONData = [[String:AnyObject]]()
        return jobTransactionDetailJSONData
    }
    //As shown above
    func getJobScheduleDateTimeJSONData() -> [[String: AnyObject]] {
        let jobScheduleDateTimeJSONData = [[String: AnyObject]]()
        return jobScheduleDateTimeJSONData
    }
    //As shown above
    func getJobTasksJSONData() -> [[String: AnyObject]] {
        let jobTasksJSONData = [[String: AnyObject]]()
        return jobTasksJSONData
    }
    //As shown above
    func getJobRecordTimeJSONData() -> [[String: AnyObject]] {
        let jobRecordTimeJSONData = [[String: AnyObject]]()
        return jobRecordTimeJSONData
    }
    //As shown above
    func getNoteJSONData() -> [[String: AnyObject]] {
        let noteJSONData = [[String: AnyObject]]()
        return noteJSONData
    }
    //As shown above
    func getPhotoJSONData() -> [[String: AnyObject]] {
        let photoJSONData = [[String: AnyObject]]()
        return photoJSONData
    }
    
    //request Post
    func callTASQPostAPIClient(APIURL: String, parameters: Parameters)
    {
        Alamofire.request(APIURL,method: .post,parameters: parameters).validate().responseJSON { response in
            switch response.result {
                case .success(let value):
                    let swiftyJsonVar = JSON(value)
                    print(swiftyJsonVar)
                    let isSuccessed = swiftyJsonVar["IsSuccessed"].stringValue
                    
                    if isSuccessed == "YES" {

                    }else {
                        
                    }
                case .failure(let error):
                    print(error)
            }
        }
    }
    
    //request Get
    func callTASQGetAPIClient(APIURL: String)
    {
        Alamofire.request(APIURL).validate().responseJSON { response in
            switch response.result {
                case .success(let value):
                    let swiftyJsonVar = JSON(value)
                    print(swiftyJsonVar)
                    let isSuccessed = swiftyJsonVar["IsSuccessed"].stringValue
                    
                    if isSuccessed == "YES" {

                    }else {
                        
                    }
                case .failure(let error):
                    print(error)
            }
        }
    }
}
