//
//  LeaveAPI.swift
//  TASQSample
//
//  Created by cheng on 2019/10/23.
//  Copyright © 2019 au.com.tasq. All rights reserved.
//

import Foundation
import UIKit
import Alamofire
import SwiftyJSON

class LeaveAPI: UIViewController {
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any ladditional setup after loading the view.
//        callCreateLeaveApi()
//
//        callEditLeaveApi()
//
//        callDeleteLeaveApi()
//
//        callGetLeaveListApi()
    }
    
    //Create
    func callCreateLeaveApi()
    {
        let leave: Leave = Leave()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Staff/CreateLeave"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String:AnyObject]()
        var arrayData = [String:AnyObject]()

        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?

        var leaveData = [String:AnyObject]()
        leaveData["LeaveID"] = "" as AnyObject
        leaveData["ReferenceNO"] = leave.ReferenceNO! as AnyObject?
        leaveData["StaffID"] = leave.StaffID! as AnyObject?
        leaveData["LeaveType"] = leave.LeaveType! as AnyObject?
        leaveData["StartTime"] = leave.StartTime! as AnyObject?
        leaveData["EndTime"] = leave.EndTime! as AnyObject?
        leaveData["Totalhours"] = leave.Totalhours! as AnyObject?
        leaveData["hasApproval"] = leave.hasApproval! as AnyObject?
        leaveData["IsDeleted"] = leave.IsDeleted! as AnyObject?
        leaveData["CreateTimeUTC"] = leave.CreateTimeUTC! as AnyObject?
        leaveData["CreatedBy"] = leave.CreatedBy! as AnyObject?
        leaveData["LastModifiedTimeUTC"] = leave.LastModifiedTimeUTC! as AnyObject?
        leaveData["LastModifiedBy"] = leave.LastModifiedBy! as AnyObject?
        leaveData["Memo"] = leave.Memo as AnyObject?
        
        parameters["Leave"]  = leaveData as AnyObject
    
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    //Edit
    func callEditLeaveApi()
    {
        let leave: Leave = Leave()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Staff/EditLeave"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String:AnyObject]()
        var arrayData = [String:AnyObject]()

        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?

        var leaveData = [String:AnyObject]()
        leaveData["LeaveID"] = "" as AnyObject
        leaveData["ReferenceNO"] = leave.ReferenceNO! as AnyObject?
        leaveData["StaffID"] = leave.StaffID! as AnyObject?
        leaveData["LeaveType"] = leave.LeaveType! as AnyObject?
        leaveData["StartTime"] = leave.StartTime! as AnyObject?
        leaveData["EndTime"] = leave.EndTime! as AnyObject?
        leaveData["Totalhours"] = leave.Totalhours! as AnyObject?
        leaveData["hasApproval"] = leave.hasApproval! as AnyObject?
        leaveData["IsDeleted"] = leave.IsDeleted! as AnyObject?
        leaveData["CreateTimeUTC"] = leave.CreateTimeUTC! as AnyObject?
        leaveData["CreatedBy"] = leave.CreatedBy! as AnyObject?
        leaveData["LastModifiedTimeUTC"] = leave.LastModifiedTimeUTC! as AnyObject?
        leaveData["LastModifiedBy"] = leave.LastModifiedBy! as AnyObject?
        leaveData["Memo"] = leave.Memo as AnyObject?
        leaveData["Memo"] = leave.LeaveTypeName as AnyObject?
        
        parameters["Leave"]  = leaveData as AnyObject
    
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    //delete
    func callDeleteLeaveApi()
    {
        let leave: Leave = Leave()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Staff/DeleteLeave"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String:AnyObject]()
        var arrayData = [String:AnyObject]()

        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?
        
        parameters["ID"]  = leave.LeaveID! as AnyObject?
        parameters["NeedValidate"]  = "NO" as AnyObject?
    
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    func callGetLeaveListApi()
    {
        let leave: Leave = Leave()
        let loginDetail: LoginDetail = LoginDetail()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl
        let type: String = "all"
        let startTime: String = ""
        let endTime: String = ""
        let staffID: [String] = [leave.StaffID!]
        var arrayData = [String:AnyObject]()
        
        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        let jasonLoginDeail = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: arrayData as [String : AnyObject])
        
        let jsonStaffID = TASQSampleCommonLibrary.convertArrayToJSONData(arrData: staffID as [AnyObject])
        
        let attachedURL: String = "&Type=" + type + "&StartTime=" + startTime + "&EndTime=" + endTime  + "&StaffID=" + jsonStaffID
        
        let EncodeAttachedURL = (jasonLoginDeail + attachedURL).addingPercentEncoding(withAllowedCharacters: .urlHostAllowed )! as String
        
        let url : String = UrlString + "Staff/GetLeaveList?Jsonlogin="  + EncodeAttachedURL
    
        let replacedUrlString = url.replacingOccurrences(of: "\\", with:"" )
        
        let request = NSMutableURLRequest(url: NSURL(string: replacedUrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        request.httpMethod = "GET"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    //request Post
    func callTASQPostAPIClient(APIURL: String, parameters: Parameters)
    {
        Alamofire.request(APIURL,method: .post,parameters: parameters).validate().responseJSON { response in
            switch response.result {
                case .success(let value):
                    let swiftyJsonVar = JSON(value)
                    print(swiftyJsonVar)
                    let isSuccessed = swiftyJsonVar["IsSuccessed"].stringValue
                    
                    if isSuccessed == "YES" {

                    }else {
                        
                    }
                case .failure(let error):
                    print(error)
            }
        }
    }
    
    //request Get
    func callTASQGetAPIClient(APIURL: String)
    {
        Alamofire.request(APIURL).validate().responseJSON { response in
            switch response.result {
                case .success(let value):
                    let swiftyJsonVar = JSON(value)
                    print(swiftyJsonVar)
                    let isSuccessed = swiftyJsonVar["IsSuccessed"].stringValue
                    
                    if isSuccessed == "YES" {

                    }else {
                        
                    }
                case .failure(let error):
                    print(error)
            }
        }
    }
}
