//
//  TASQSampleCommonLibrary.swift
//  TASQSample
//
//  Created by cheng on 2019/10/22.
//  Copyright © 2019 au.com.tasq. All rights reserved.
//

import Foundation
import UIKit

public class TASQSampleCommonLibrary
{
    static let TASQApiUrl = "https://jobapi.tasq.com.au/api/"
    
    static let TASQApiTOKEN = "b3b777b0-c7af-458d-be64-b3d6d760177f"

    static func convertDictionaryToJSONData(dicData:[String:AnyObject])-> String
    {
        var returnString = ""
        
        do{
            
            let jsonData = try JSONSerialization.data(withJSONObject: dicData, options: [])
            
            let jsonString = NSString(data: jsonData, encoding: String.Encoding.utf8.rawValue)! as String
            returnString = jsonString
            
            //      print(jsonString)
            //          returnString = jsonString.stringByReplacingOccurrencesOfString("\\",  withString:"")
            //
            //        print(returnString)
        }catch{
            
        }
        
        
        return returnString
    }
    
    static func convertArrayToJSONData(arrData: [AnyObject])-> String
    {
        if (!JSONSerialization.isValidJSONObject(arrData)) {
            print("无法解析出JSONString")
            return ""
        }
         
        let data : NSData! = try? JSONSerialization.data(withJSONObject: arrData, options: []) as NSData?
        let JSONString = NSString(data: data as Data,encoding: String.Encoding.utf8.rawValue)
        return JSONString! as String
    }
    
    static func getIPAddresses() -> String {
        var addresses = [String]()
        
        // Get list of all interfaces on the local machine:
        var ifaddr : UnsafeMutablePointer<ifaddrs>? = nil
        if getifaddrs(&ifaddr) == 0 {
            var ptr = ifaddr
            repeat{
                
                let flags = Int32((ptr?.pointee.ifa_flags)!)
                var addr = ptr?.pointee.ifa_addr.pointee
                
                // Check for running IPv4, IPv6 interfaces. Skip the loopback interface.
                if (flags & (IFF_UP|IFF_RUNNING|IFF_LOOPBACK)) == (IFF_UP|IFF_RUNNING) {
                    if addr?.sa_family == UInt8(AF_INET) || addr?.sa_family == UInt8(AF_INET6) {
                        
                        // Convert interface address to a human readable string:
                        var hostname = [CChar](repeating: 0, count: Int(NI_MAXHOST))
                        if (getnameinfo(&addr!, socklen_t((addr?.sa_len)!), &hostname, socklen_t(hostname.count),nil, socklen_t(0), NI_NUMERICHOST) == 0) {
                            
                            //String(
                            if let address = String(validatingUTF8: hostname) {
                                addresses.append(address)
                            }
                        }
                    }
                }
                ptr = ptr?.pointee.ifa_next
                
            }while (ptr != nil)

            freeifaddrs(ifaddr)
        }
        return addresses[0]   //return public IP ,addresses[1] return private ip
    }
    
    static func getMobileDeviceToken()->String
    {
        let deviceID = UIDevice.current.identifierForVendor?.uuidString
        return deviceID!
    
    }
    
    static func convertStringToDateStr(DateStr: String) ->String
    {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd'T'HH:mm:ss" //Your date format
        let date = dateFormatter.date(from: DateStr)
     
        let myFormatter = DateFormatter()
        myFormatter.dateStyle = .short
        myFormatter.dateFormat = "dd/MM/yyyy"
      let convertedDateStr =  myFormatter.string(from: date!)
        return convertedDateStr
        
    }
}
