//
//  StaffAPI.swift
//  TASQSample
//
//  Created by cheng on 2019/10/23.
//  Copyright © 2019 au.com.tasq. All rights reserved.
//

import Foundation
import UIKit
import Alamofire
import SwiftyJSON

class StaffAPI: UIViewController {
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
//        callCreateStaffApi()
//
//        callEditStaffApi()
//        
//        callDeleteStaffApi()
//
//        callGetStaffListApi()
    }
    
    //Create
    func callCreateStaffApi()
    {
        let staff: Staff = Staff()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Q6/CreateStaff"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String:AnyObject]()
        var arrayData = [String:AnyObject]()

        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?

        var StaffData = [String:AnyObject]()
        StaffData["UserID"] = "" as AnyObject
        StaffData["CreateDate"] = staff.CreateDate! as AnyObject?
        StaffData["IsMain"] = staff.IsMain! as AnyObject?
        StaffData["StaffPhoto"] = staff.StaffPhoto! as AnyObject?
        
        parameters["InternalUser"]  = StaffData as AnyObject
    
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    //Edit
    func callEditStaffApi()
    {
        let staff: Staff = Staff()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Q6/EditStaff"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String:AnyObject]()
        var arrayData = [String:AnyObject]()

        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?

        var StaffData = [String:AnyObject]()
        StaffData["UserID"] = staff.UserID! as AnyObject
        StaffData["CreateDate"] = staff.CreateDate! as AnyObject?
        StaffData["IsMain"] = staff.IsMain! as AnyObject?
        StaffData["StaffPhoto"] = staff.StaffPhoto! as AnyObject?
        
        parameters["InternalUser"]  = StaffData as AnyObject
    
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    //delete
    func callDeleteStaffApi()
    {
        let staff: Staff = Staff()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl + "Q6/DeleteStaff"
        let loginDetail: LoginDetail = LoginDetail()
        var parameters = [String: AnyObject]()
        var arrayData = [String: AnyObject]()
        
        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        parameters["CompanyValidateInfo"] = arrayData as AnyObject?
        
        parameters["Email"]  = staff.LoginEmail! as AnyObject?
        
        let request = NSMutableURLRequest(url: NSURL(string: UrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        let jsonString = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: parameters)
        print(jsonString)
        request.httpBody = jsonString.data(using: String.Encoding.utf8, allowLossyConversion: true)
        request.httpMethod = "POST"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    func callGetStaffListApi()
    {
        let loginDetail: LoginDetail = LoginDetail()
        let UrlString = TASQSampleCommonLibrary.TASQApiUrl
        var arrayData = [String: AnyObject]()
        
        arrayData ["WebApiTOKEN"] = TASQSampleCommonLibrary.TASQApiTOKEN as AnyObject?
        arrayData ["LoginName"] = loginDetail.LoginEmail as AnyObject?
        arrayData ["Password"] = loginDetail.LoginPassword as AnyObject?
        arrayData ["ClientIP"] = TASQSampleCommonLibrary.getIPAddresses() as AnyObject?
        arrayData ["MobileDeviceToken"] = TASQSampleCommonLibrary.getMobileDeviceToken() as AnyObject?
        
        let jasonLoginDeail = TASQSampleCommonLibrary.convertDictionaryToJSONData(dicData: arrayData as [String : AnyObject])
        
        let attachedURL: String = ""
        
        let EncodeAttachedURL = (jasonLoginDeail + attachedURL).addingPercentEncoding(withAllowedCharacters: .urlHostAllowed )! as String
        
        let url : String = UrlString + "Item/GetStaffList?Jsonlogin="  + EncodeAttachedURL
    
        let replacedUrlString = url.replacingOccurrences(of: "\\", with:"" )
        
        let request = NSMutableURLRequest(url: NSURL(string: replacedUrlString)! as URL, cachePolicy: NSURLRequest.CachePolicy.reloadIgnoringLocalCacheData, timeoutInterval: 300)
        request.httpMethod = "GET"
        request.setValue("application/json", forHTTPHeaderField: "Content-Type")
        do {
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request as URLRequest, completionHandler: {
                (data, response, error)  in
            })
            task.resume()
        }
    }
    
    //request Post
    func callTASQPostAPIClient(APIURL: String, parameters: Parameters)
    {
        Alamofire.request(APIURL,method: .post,parameters: parameters).validate().responseJSON { response in
            switch response.result {
                case .success(let value):
                    let swiftyJsonVar = JSON(value)
                    print(swiftyJsonVar)
                    let isSuccessed = swiftyJsonVar["IsSuccessed"].stringValue
                    
                    if isSuccessed == "YES" {

                    }else {
                        
                    }
                case .failure(let error):
                    print(error)
            }
        }
    }
    
    //request Get
    func callTASQGetAPIClient(APIURL: String)
    {
        Alamofire.request(APIURL).validate().responseJSON { response in
            switch response.result {
                case .success(let value):
                    let swiftyJsonVar = JSON(value)
                    print(swiftyJsonVar)
                    let isSuccessed = swiftyJsonVar["IsSuccessed"].stringValue
                    
                    if isSuccessed == "YES" {

                    }else {
                        
                    }
                case .failure(let error):
                    print(error)
            }
        }
    }

}
